Loading...
Searching...
No Matches
itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter > Class Template Reference

`#include <itkGPUUnaryFunctorImageFilter.h>`

## Detailed Description

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>
class itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >

Implements pixel-wise generic operation on one image using the GPU.

GPU version of unary functor image filter. GPU Functor handles parameter setup for the GPU kernel.

Note
  This file was taken from ITK 4.1.0. It was modified by Denis P. Shamonin and Marius Staring. Division of Image Processing, Department of Radiology, Leiden, The Netherlands. Added functionality is described in the Insight Journal paper: http://hdl.handle.net/10380/3393

Definition at line 63 of file itkGPUUnaryFunctorImageFilter.h.

Inheritance diagram for itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >:
[legend]

## Public Types

using | ConstPointer = SmartPointer<const Self>
using | CPUSuperclass = TParentImageFilter
using | FunctorType = TFunction
using | GPUSuperclass = GPUInPlaceImageFilter<TInputImage, TOutputImage>
using | InputImagePixelType = typename InputImageType::PixelType
using | InputImagePointer = typename InputImageType::ConstPointer
using | InputImageRegionType = typename InputImageType::RegionType
using | InputImageType = TInputImage
using | OutputImagePixelType = typename OutputImageType::PixelType
using | OutputImagePointer = typename OutputImageType::Pointer
using | OutputImageRegionType = typename OutputImageType::RegionType
using | OutputImageType = TOutputImage
using | Pointer = SmartPointer<Self>
using | Self = GPUUnaryFunctorImageFilter
Public Types inherited from itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >
using | ConstPointer = SmartPointer<const Self>
using | CPUSuperclass = TParentImageFilter
using | GPUSuperclass = GPUImageToImageFilter<TInputImage, TOutputImage, TParentImageFilter>
using | InputImageConstPointer = typename InputImageType::ConstPointer
using | InputImagePixelType = typename InputImageType::PixelType
using | InputImagePointer = typename InputImageType::Pointer
using | InputImageRegionType = typename InputImageType::RegionType
using | InputImageType = TInputImage
using | OutputImagePixelType = typename GPUSuperclass::OutputImagePixelType
using | OutputImagePointer = typename GPUSuperclass::OutputImagePointer
using | OutputImageRegionType = typename GPUSuperclass::OutputImageRegionType
using | OutputImageType = typename GPUSuperclass::OutputImageType
using | Pointer = SmartPointer<Self>
using | Self = GPUInPlaceImageFilter
Public Types inherited from itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >
using | ConstPointer = SmartPointer<const Self>
using | InputImageConstPointer = typename InputImageType::ConstPointer
using | InputImagePixelType = typename InputImageType::PixelType
using | InputImagePointer = typename InputImageType::Pointer
using | InputImageRegionType = typename InputImageType::RegionType
using | InputImageType = TInputImage
using | OutputImageType = TOutputImage
using | Pointer = SmartPointer<Self>
using | Self = GPUImageToImageFilter
using | Superclass = TParentImageFilter

## Public Member Functions

virtual const char * | GetClassName () const
FunctorType & | GetFunctor ()
const FunctorType & | GetFunctor () const
| ITK_DISALLOW_COPY_AND_MOVE (GPUUnaryFunctorImageFilter)
| itkStaticConstMacro (InputImageDimension, unsigned int, TInputImage::ImageDimension)
| itkStaticConstMacro (OutputImageDimension, unsigned int, TOutputImage::ImageDimension)
void | SetFunctor (const FunctorType &functor)
Public Member Functions inherited from itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >
| ITK_DISALLOW_COPY_AND_MOVE (GPUInPlaceImageFilter)
| itkStaticConstMacro (InputImageDimension, unsigned int, TInputImage::ImageDimension)
| itkStaticConstMacro (OutputImageDimension, unsigned int, TOutputImage::ImageDimension)
Public Member Functions inherited from itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >
virtual bool | GetGPUEnabled () const
virtual void | GPUEnabledOff ()
virtual void | GPUEnabledOn ()
void | GraftOutput (const DataObjectIdentifierType &key, DataObject *graft) override
void | GraftOutput (DataObject *graft) override
| ITK_DISALLOW_COPY_AND_MOVE (GPUImageToImageFilter)
| itkStaticConstMacro (InputImageDimension, unsigned int, TInputImage::ImageDimension)
| itkStaticConstMacro (OutputImageDimension, unsigned int, TOutputImage::ImageDimension)
virtual void | SetGPUEnabled (bool _arg)
void | SetNumberOfWorkUnits (ThreadIdType _arg) override

## Static Public Member Functions

static Pointer | New ()
Static Public Member Functions inherited from itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >
static Pointer | New ()

## Protected Member Functions

void | GenerateOutputInformation () override
void | GPUGenerateData () override
| GPUUnaryFunctorImageFilter ()=default
| ~GPUUnaryFunctorImageFilter () override=default
Protected Member Functions inherited from itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >
void | AllocateOutputs () override
| GPUInPlaceImageFilter ()=default
void | PrintSelf (std::ostream &os, Indent indent) const override
void | ReleaseInputs () override
| ~GPUInPlaceImageFilter () override=default
Protected Member Functions inherited from itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >
void | GenerateData () override
| GPUImageToImageFilter ()
void | PrintSelf (std::ostream &os, Indent indent) const override
| ~GPUImageToImageFilter () override=default

## Protected Attributes

int | m_UnaryFunctorImageFilterGPUKernelHandle {}
Protected Attributes inherited from itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >
OpenCLKernelManager::Pointer | m_GPUKernelManager {}

## Private Attributes

FunctorType | m_Functor {}

## Member Typedef Documentation

## ConstPointer

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::ConstPointer = SmartPointer<const Self>

Definition at line 74 of file itkGPUUnaryFunctorImageFilter.h.

## CPUSuperclass

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::CPUSuperclass = TParentImageFilter

Definition at line 71 of file itkGPUUnaryFunctorImageFilter.h.

## FunctorType

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::FunctorType = TFunction

Some typedefs.

Definition at line 83 of file itkGPUUnaryFunctorImageFilter.h.

## GPUSuperclass

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::GPUSuperclass = GPUInPlaceImageFilter<TInputImage, TOutputImage>

Definition at line 72 of file itkGPUUnaryFunctorImageFilter.h.

## InputImagePixelType

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::InputImagePixelType = typename InputImageType::PixelType

Definition at line 88 of file itkGPUUnaryFunctorImageFilter.h.

## InputImagePointer

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::InputImagePointer = typename InputImageType::ConstPointer

Definition at line 86 of file itkGPUUnaryFunctorImageFilter.h.

## InputImageRegionType

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::InputImageRegionType = typename InputImageType::RegionType

Definition at line 87 of file itkGPUUnaryFunctorImageFilter.h.

## InputImageType

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::InputImageType = TInputImage

Definition at line 85 of file itkGPUUnaryFunctorImageFilter.h.

## OutputImagePixelType

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::OutputImagePixelType = typename OutputImageType::PixelType

Definition at line 93 of file itkGPUUnaryFunctorImageFilter.h.

## OutputImagePointer

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::OutputImagePointer = typename OutputImageType::Pointer

Definition at line 91 of file itkGPUUnaryFunctorImageFilter.h.

## OutputImageRegionType

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::OutputImageRegionType = typename OutputImageType::RegionType

Definition at line 92 of file itkGPUUnaryFunctorImageFilter.h.

## OutputImageType

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::OutputImageType = TOutputImage

Definition at line 90 of file itkGPUUnaryFunctorImageFilter.h.

## Pointer

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::Pointer = SmartPointer<Self>

Definition at line 73 of file itkGPUUnaryFunctorImageFilter.h.

## Self

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

using itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::Self = GPUUnaryFunctorImageFilter

Standard class typedefs.

Definition at line 70 of file itkGPUUnaryFunctorImageFilter.h.

## Constructor & Destructor Documentation

## GPUUnaryFunctorImageFilter()

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::GPUUnaryFunctorImageFilter | ( |  | ) |

protected default

## ~GPUUnaryFunctorImageFilter()

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::~GPUUnaryFunctorImageFilter | ( |  | ) |

override protected default

## Member Function Documentation

## GenerateOutputInformation()

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

void itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::GenerateOutputInformation | ( |  | ) |

override protected

## GetClassName()

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

virtual const char * itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::GetClassName | ( |  | ) | const

virtual

Run-time type information (and related methods).

Reimplemented from itk::GPUInPlaceImageFilter< TInputImage, TOutputImage, TParentImageFilter >.

## GetFunctor() [1/2]

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

FunctorType & itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::GetFunctor | ( |  | ) |

inline

Definition at line 100 of file itkGPUUnaryFunctorImageFilter.h.

## GetFunctor() [2/2]

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

const FunctorType & itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::GetFunctor | ( |  | ) | const

inline

Definition at line 107 of file itkGPUUnaryFunctorImageFilter.h.

## GPUGenerateData()

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

void itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::GPUGenerateData | ( |  | ) |

override protected virtual

Reimplemented from itk::GPUImageToImageFilter< TInputImage, TOutputImage, TParentImageFilter >.

## ITK_DISALLOW_COPY_AND_MOVE()

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::ITK_DISALLOW_COPY_AND_MOVE | ( | GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter > |  | ) |

## itkStaticConstMacro() [1/2]

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::itkStaticConstMacro | ( | InputImageDimension | ,
|  | unsigned int | ,
|  | TInputImage::ImageDimension | )

ImageDimension constants

## itkStaticConstMacro() [2/2]

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::itkStaticConstMacro | ( | OutputImageDimension | ,
|  | unsigned int | ,
|  | TOutputImage::ImageDimension | )

## New()

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

Pointer itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::New | ( |  | ) |

static

Method for creation through the object factory.

## SetFunctor()

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

void itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::SetFunctor | ( | const FunctorType & | functor | ) |

inline

Set the functor object.

Definition at line 115 of file itkGPUUnaryFunctorImageFilter.h.

## Field Documentation

## m_Functor

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

FunctorType itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::m_Functor {}

private

Definition at line 141 of file itkGPUUnaryFunctorImageFilter.h.

## m_UnaryFunctorImageFilterGPUKernelHandle

template<typename TInputImage, typename TOutputImage, typename TFunction, typename TParentImageFilter = InPlaceImageFilter<TInputImage, TOutputImage>>

int itk::GPUUnaryFunctorImageFilter< TInputImage, TOutputImage, TFunction, TParentImageFilter >::m_UnaryFunctorImageFilterGPUKernelHandle {}

protected

GPU kernel handle is defined here instead of in the child class because GPUGenerateData() in this base class is used.

Definition at line 138 of file itkGPUUnaryFunctorImageFilter.h.

Generated on 1768596610 for elastix by 1.15.0 |